#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_dbc.pl
# !*-------------------------------------------------------------------------

$ProgName = dbamon_inhibit.pl;
require "cgi_handlers.pl";

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# General parms required
$DBdir         = "/var/opt/apache/htdocs/cftasks";
$modlockfile   = "$DBdir/modlock";
$entlockfile   = "$DBdir/entlock";
$conlockfile   = "$DBdir/conlock";
$modfile       = "$DBdir/modEntries";
$cfteamFile    = "$DBdir/cfteam";
$entityFile    = "$DBdir/entities";
$date          = `date`;
$keyStart      = 1000;

$| = 1;
$readfile      = "/tmp/dbamon_text.txt";

$data_source = "dbi:mysql";
$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#-----------------------------------------------------------------------------
sub displayError {
   local($errorMsg,@error_fields) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $statement";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   if ($entLocked) { close(ENTLOCKFILE); unlink($entlockfile); }
   if ($conLocked) { close(CONLOCKFILE); unlink($conlockfile); }
   if ($modLocked) { close(MODLOCKFILE); unlink($modlockfile); }
   if ($dbLocked)  { &unlockDb; }

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDBOld
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub selectData
{
  # Create the SQL SELECT statement
  $statement  = "select 
     text
    from dbamon.dbcactive 
    where 
      i_hosts = $i_hosts
      and dbamonmode = '$mode'
    order by 1
   ";
  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');


  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $_ = $Data[0];
    @words = split;
    $i = -1;
    $valu = "";
    foreach (@words) 
    {
      ++$i;
      if ($i == 0) { $parm  = $_; }
      else         { $valu .= " " . $_; }
    }
    if ($parm =~ /DBCFileName/)
    {
      print "<font size=2><b><u>$parm</u></b><p>\n";
    }
    else
    {
      if (! $hdr_flag)
      {
	print "<table border=1 bgcolor=linen>\n";
	print "<tr bgcolor=slate><th><h5>Parameter<th><h5>Value</tr>\n";
        $hdr_flag = 1;
      }
      print "<tr><td nowrap><font size=2>$parm<td><b><font size=2>$valu</b>\n";
    }

    $selectcount++;
  }

  print "</table>\n";
  print "<hr><i><font size=2>(Rows Selected: $selectcount)</i>\n";
}
































# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

############################## Subroutines ###################################
sub IntHandler
{
   local($Signal) = @_;
   close(you_fill_in_the_file_descriptor);
   unlink($you_fill_in_the_tmp_file_name);
   exit(0);
}

sub error_html {
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

sub custom_html {

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

###############################################################################
# Attempt to make sure that no meta characters are entered in the form.
#------------------------------------------------------------------------------

sub CheckForEvilness
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}


############## Main  ##########################
$SaveFile = "/tmp/dbamon_dbc.log";
unlink($SaveFile);
chop($CurrentDate = `date`);

&get_request;

$_      = @ARGV[0];
@words  = split(/-/);
$i_hosts = @words[0];
$mode    = @words[1];
$tempfl = "/tmp/dbamon_dbc.txt";

open(LOG, ">>$SaveFile" );
print LOG "$CurrentDate : i_hosts=$filename\n";

print "Content-type: text/html\n\n
  <title>DBAmon DBC Viewer</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>DBC Viewer</center>
  </table>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>

 $links_include

</table>
<hr>
";


print "<h5>DBAmon Instance Configuration (DBC) Settings - Host Number: $i_hosts Mode: $mode</h5><hr><p>\n";

# Connect to DB
&connectDB;

# Connect to DB
&selectData;

print "</table>\n";

close(LOG);
exit;
