#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin:/opt/dbamon/ploticus";
# !+-------------------------------------------------------------------------
#
#    Name:  dbamon_plot.pl
#
# !*-------------------------------------------------------------------------

$| = 1;

## chop($P = `basename $0`); 
$P = "dbamon_plot"; 
$P =~ s/\.pl$//g;

push(@INC,"/opt/dbamon/lib");
require "cgi_handlers.pl";
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

use DBI;

$maxrows = 1000;
$days    = 180;
$debug   = 0;

#---- PL Vars
mkdir "/opt/dbamon/dat/dyn" if (! -e "/opt/dbamon/dat/dyn"); 

#---- Old
## chop($pl_date = `date +%Y%m%d_%H%M%S`);
#---- New
$pl_date = getdate();
$pl_date =~ s/\///g;
$pl_date =~ s/\://g;
$pl_date =~ s/\-/_/;

$pl_v1_file = "/opt/dbamon/dat/dyn/${P}_v1_${pl_date}_${$}.txt"; 
$csv_v1_file_short = "${P}_v1_${pl_date}_${$}.csv"; 
$csv_v1_file = "/opt/dbamon/dat/dyn/$csv_v1_file_short"; 

#---- Read WWW_Check:
$font = &readRC("WWW_Font:");
$font = "arial" if ! $font;

$http_host = $ENV{'HTTP_HOST'};
$script_name = $ENV{'SCRIPT_NAME'};

#---- Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#-----------------------------------------------------------------------------
#
# Subs
#
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
sub PL_SingleLine
#-----------------------------------------------------------------------------
{
  if ($debug)
  {
    &msg("Input file - plot_parm=$plot_parm"); 
    $ls = `ls -l $plot_parm`; 
    &msg("  $ls"); 
  }

  #---- Read linecnt from input file
  $plfile_cnt = 0;
  open(PLFILE,"$plot_parm") || &error("Cannot open input $plot_parm - $!"); 
  while(<PLFILE>) 
  {
    $plfile_cnt++; 
    #@words = split(/\,/,$_); 
    @words = split; 
    $lastval = $words[1]; 
  }
  $movingavgcount = int($plfile_cnt / 5); 
  $movingavgcount = 2 if $movingavgcount == 0;
  &msg("PL_SingleLine - Starting - Plot data file $plot_parm has $plfile_cnt records - movingavgcount=$movingavgcount lastval=$lastval"); 
  
  $ENV{'DBAMON_PL_FILE'} = $plot_parm; 
  $ENV{'DBAMON_PL_INSTANCE'} = $plot_parm1; 
  $ENV{'DBAMON_PL_METRIC'} = $plot_parm2; 
  $ENV{'DBAMON_PL_MOVINGAVGCOUNT'} = $movingavgcount; 
  $ENV{'DBAMON_PL_LASTVAL'} = $lastval; 

  $cmd = "dbamon_pl_run SingleLine";
  &msg("Invoking Ploticus - cmd=($cmd)"); 

  ##$debug = 1; 

  #---- Old
  $cmdout = `$cmd 2>&1`; 

  #---- New
  ##$rc = system("cmd 2>&1"); 
  ##&msg("Back from $cmd - rc=$rc"); 

  if ($debug)
  {
    &msg("Back from $cmd"); 
    &msg("Output:"); 
    print "<pre>$cmdout</pre>"; 
  }

  $png_file = ""; 
  foreach (split(/\n/, $cmdout))
  {
    @words = split;
    $png_file = $words[1] if /^PNG_File: /;
  }

  if (! $png_file)
  {
    &msg("Output:"); 
    print "<pre>$cmdout</pre>"; 
    &error("PL Program did not work since there is no resulting PNG file") if ! $png_file; 
  }
 
  print "<p><img src='/dbamon/graphs/dyn/$png_file' border=1><br>\n"; 

  &msg("Resulting JPEG File - $png_file"); 

  &msg("PL_SingleLine - Done");
}

#-----------------------------------------------------------------------------
sub selectDataInstance
#-----------------------------------------------------------------------------
{
  &msg("selectDataInstance - Starting"); 
  $s_time = time;

  #      [dbamonmode]
  #     ,[instance]
  #     ,[system]
  #     ,[dbms]
  #     ,[category]
  #     ,[parm]
  #     ,[value]
  #     ,[value2]
  #     ,[value3]
  #     ,[value4]
  #     ,[ts]
  #     ,[zdate]

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "M")
  {
    $sql  = "select 
	category, 
	parm,
        count(*),
        min(ts),
        max(ts)
      from 
	dbamon.history 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
	and ts >= dateadd(dd,-$days,getdate())
      group by
	category, 
	parm
      order by 1, 2
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }
  &msg("Running sql=$sql") if $debug; 

  &msg("Querying DBAMON.HISTORY data for instance_key=($instance) and mode=$mode for the last $days days");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  print "<p>
  <h3>DBAmon Metrics / Parms Available for DBAmonMode=$mode InstanceKey=($instance) </h3>
  <table border=0 bgcolor=wheat $style_normal>
  
  \n";
  print "
  <tr bgcolor=slateblue>
    <th><h5>Metric / Metric Parm 
    <th><h5>Min<br> Date 
    <th><h5>Max<br> Date 
    <th><h5>Row<br> Count 
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $count  = shift(@Data);  
    $mindate  = shift(@Data);  
    $maxdate  = shift(@Data);  

    #if ($parm eq "." || ! $parm)
    #{
    #  $where = "category = QQ${categ}QQ"; 
    #}
    #else
    #{
    #  $where = "category = QQ${categ}QQ and parm = QQ${parm}QQ "; 
    #}

    $bg = &bgRow;

    print "<tr $bg>
      <td $style_normal> <b> <a href='http://$http_host/${script_name}?$mode,$instance,$categ,$parm'>$categ / $parm</a>  </b>
      <td $style_normal>  $mindate  
      <td $style_normal>  $maxdate  
      <td $style_normal align=right>  $count 
    "; 

    if (++$selectcount > $maxrows) 
    { 
      print "<tr bgcolor=pink><td colspan=99><b><font size=2>MaxRows threshold of $maxrows exceeded\n";
      print "</table>\n";
      return; 
    }
  }

  print "</table>\n";

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }

  print "</table>\n";
  &msg("Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub selectDataDetail
#-----------------------------------------------------------------------------
{
  &msg("selectDataDetail - Starting - in_categ=$in_categ"); 
  $s_time = time;

  #      [dbamonmode]
  #     ,[instance]
  #     ,[system]
  #     ,[dbms]
  #     ,[category]
  #     ,[parm]
  #     ,[value]
  #     ,[value2]
  #     ,[value3]
  #     ,[value4]
  #     ,[ts]
  #     ,[zdate]

  if ($in_categ eq "SERVER_MEM") { $categ_desc = "Server RAM Utilization"; $parm_desc = "N/A";    $v1_desc = "RAM % Used";  $v2_desc = "Total RAM"; $v3_desc = "Used RAM";  } 
  if ($in_categ eq "TLOG_RATIO") { $categ_desc = "TLog/DBSize Ratio";      $parm_desc = "DBName"; $v1_desc = "TL/DB Ratio"; $v2_desc = "TLog Size"; $v3_desc = "DB Size";   } 

  # Create the SQL SELECT statement
  if ($dbamon_repos eq "M")
  {
    $sql  = "
      select 
	dbamon.dateconvert_19(ts), 
	system, 
	instance, 
        dbms,
	category, 
	parm,
	value,
	value2,
	value3,
	value4 
      from 
	dbamon.history 
      where 
	instance = '$instance' 
        and dbamonmode = '$mode'
        and category = '$in_categ'
        and parm = '$in_parm'
	and ts >= dateadd(dd,-183,getdate())
      order by ts desc
    ";
  }
  else
  {
    &error("This SQL is not yet coded for repository ORACLE"); 
  }
  &msg("DEBUG - sql=$sql") if $debug; 

  &msg("Querying DBAMON.HISTORY data for this instance for the last six months");
  ##&msg("WHERE Clause: instance = '$instance' $where2 $where3");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  $cell_width = 60;

  &msg("Query elapsed time: $elapsed seconds");

  print "<h3> DBAmon Metric Data For: DBAmonMode=$mode InstanceKey=($instance) - MetricCategory=$in_categ Parm=$in_parm </h3>\n"; 
  print "<p><table border=0 bgcolor=wheat $style_normal >\n";
  print "<tr bgcolor=slateblue>
    <th><h5>Timestamp
    <th><h5>Server 
    <th><h5>Instance
    <th><h5>DBMS
    <th nowrap><h5>Metric 
    <th><h5>Metric<br> Parm <br>(If Any)
    <th nowrap><h5>Value1
    <th nowrap><h5>Value2
    <th nowrap><h5>Value3
    <th nowrap><h5>Value4
  \n";
  print "<tr bgcolor=slateblue>
    <th colspan=4 align=left><h5>Glossary (If Any): 
    <th nowrap><h5>[$categ_desc]
    <th nowrap><h5>[$parm_desc] 
    <th nowrap><h5>[$v1_desc]
    <th nowrap><h5>[$v2_desc]
    <th nowrap><h5>[$v3_desc]
    <th nowrap><h5>[$v4_desc]
  \n";
  print "<tr bgcolor=wheat>
    <th colspan=4 align=left><h5>Available Plots: 
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
    <th nowrap> <a href='dbamon_plot?makePlot?metrics_singleval?$pl_v1_file'<b> Value1 Plot </b></a> 
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
  \n";
  print "<tr bgcolor=wheat>
    <th colspan=4 align=left><h5>Available CSV Files: 
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
    <th nowrap> <a href='/dyn/$csv_v1_file_short'<b> Value1 CSV </b></a> 
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
    <th nowrap> &nbsp;
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = shift(@Data); 
    $sy    = shift(@Data);  
    $in    = shift(@Data);  
    $dbms  = shift(@Data);  
    $categ = shift(@Data);  
    $parm  = shift(@Data);  
    $v1    = shift(@Data);  
    $v2    = shift(@Data);  
    $v3    = shift(@Data);  
    $v4    = shift(@Data);  

    $bg = &bgRow;

    print "<tr $bg>
      <td $style_normal> $ts 
      <td $style_normal> $sy 
      <td $style_normal> $in 
      <td $style_normal> $dbms 
      <td $style_normal> <b> $categ </b>
      <td $style_normal> <b> $parm </b>
      <td $style_normal align=right width=$cell_width> <b> $v1 </b>
      <td $style_normal align=right width=$cell_width> <b> $v2 </b>
      <td $style_normal align=right width=$cell_width> <b> $v3 </b>
      <td $style_normal align=right width=$cell_width> <b> $v4 </b>
    "; 

    #---- Data for ploticus
    $pl_ts  = substr($ts,0,10) . "." . substr($ts,11,5); 

    $pl_v1_vals{$pl_ts} = $vi; 

    if (++$selectcount > $maxrows) 
    { 
      print "<tr bgcolor=pink><td colspan=99><b><font size=2>MaxRows threshold of $maxrows exceeded\n";
      print "</table>\n";
      return; 
    }
  }

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";
  &msg("Rows Selected: $selectcount");

  #---- Write ploticus data
  if ($pl_ts)
  {
    #---- v1 File
    &msg("Writing plot data to $pl_v1_file"); 
    open(PL,">$pl_v1_file") || &error("Cannot open output $pl_v1_file - $!"); 
    $pl_cnt = 0;
    foreach $this_key (sort keys %pl_vi_vals)
    {
      print PL "$this_key $pl_vals{$this_key}\n"; 
      $pl_cnt++; 
    }
    close(PL); 
    &msg("Wrote $pl_cnt records to $pl_v1_file"); 
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$verb       = $words[0];
$plot_parm  = $words[1];
$plot_parm1 = $words[2];
$plot_parm2 = $words[3];

&header("Plot/Chart Generator") if $ENV{'DBAMON_NOWEB'} != 1; 
&msg("Starting - verb=$verb - plot_parm=($plot_parm) plot_parm1=($plot_parm1) plot_parm2=($plot_parm2)");

#exit;
#&connectDB;

#---- Call according to parms passed 
if ($verb eq "metricsSingleval") 
{
  &PL_SingleLine;
}
else { &error("Unknown verb=$verb - Exiting"); }

#---- Terminate
&msg("Done");
exit 0;
