#!/usr/local/bin/perl
#======================================================================
# oraadmin
#======================================================================
# Env:
#  - ORACLE_HOME and ORACLE_SID must be set
#  - PATH must include ORACLE_HOME/bin
#  - You must be running an ID with gid=dba
# Usage:
#  - Run 'oraadmin --' to view usage table
# Author:
#  - Bill Border (Agilent Technologies) 03/2000
# Changes:
#
#   Ver  Date    Programmer   Desc
#   ==== ======= ============ =========================================
#   1.29 01Jan01 Craig Geier  Added -killbackup  Kills Running Backups
#   1.30 06Jul01 Craig Geier  Added -resize_redo Resizes redo logs
#   1.31 10Aug01 Craig Geier  Re-wrote -startup and -shutdown 
#   1.32 15Nov01 Craig Geier  Added -resize_df 
#   2.00 26Nov01 Bill Border  Added code to tolerate 9i. 
#   2.01 28Nov01 Bill Border  Added -arclog_on and -arclog_off
#   2.02 03Dec01 Bill Border  Added -listbounce
#   2.03 04Dec01 Bill Border  Converted entire pgm to use $os_scmd
#======================================================================
$version = "2.03";

$arg  = $ARGV[0];
$arg2 = $ARGV[1];
$arg3 = $ARGV[2];
$arg4 = $ARGV[3];
$arg5 = $ARGV[4];
$P = "orantadmin";
$tmpfile = "/tmp/$P.$$.tmp";
$tmpfile2 = "/tmp/$P.$$.sql";
$sqlin = "c:\\temp\\orantstat_sqlin_${pid}.tmp";
$| = 1; 

$oh = $ENV{"ORACLE_HOME"};
$os = $ENV{"ORACLE_SID"};

if (-f "$oh/bin/svrmgr30")
{
  $oraver = "8";
  $sqlcmd = "sv";
  $os_scmd = "svrmgrl";
  $os_conn = "connect internal ";
}
else
{
  $oraver = "8i";
  $sqlcmd = "sp";
  $os_scmd = "sqlplus /NOLOG";
  $os_conn = "connect / as sysdba ";
}

&msg("oraver=$oraver sqlcmd=$sqlcmd");

if (($arg eq "-stop" || $arg eq "-shutdown") && $arg2 ne "" ) 
{
  null;
}
elsif (($arg eq "-start" || $arg eq "-startup") && $arg2 ne "" ) 
{
  null;
}
elsif ($oh eq "" || $os eq "") 
{
  print "oraadmin | Env vars ORACLE_HOME and ORACLE_SID must be set\n";
  exit 1;
}

chop($host = `hostname`);

#$compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`;
#chop $compwork;
#@words = split(/\./,$compwork);
#$nexttolast = $#words - 1;
#$company = @words[$nexttolast];

#system("echo '' | mailx -s 'monitor--oraadmin $arg $host' border\@curley.cos.agilent.com");

&msg("Version=$version ORACLE_SID=$os ORACLE_HOME=$oh");

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  #print "$date ${P} | $msgmsg\n";

  @sysdate = localtime;
  for ($i = 0; $i <= 5; $i++)
  {
    if (@sysdate[$i] < 10)
    {
      @sysdate[$i] = 0 . @sysdate[$i];
    }
  }
  $sysdate = @sysdate[5]+1900 . "/" . ++@sysdate[4] . "/" . @sysdate[3] . "-" . @sysdate[2] . ":" . @sysdate[1] . ":" . @sysdate[0];
  print "$sysdate ${P} | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub oraSQL
#------------------------------------------------------------------------------
{
  $sql        = $_[0];
  $foreground = $_[1];

  if ($sqlcmd eq "sp")
  {
    $os_scmd = "sqlplus /NOLOG";
    $os_conn = "connect / as sysdba ";
    $os_set1 = "set linesize 9999";
    $os_set2 = "set numwidth 20";
    $os_end  = "/";
  }
  else
  {
    $os_scmd = "$os_scmd";
    $os_conn = "$os_conn ";
    $os_end  = "";
  }
  ##&msg("os_scmd=$os_scmd os_conn=$os_conn");

  open (SQLIN,">$sqlin");
  print SQLIN "$os_conn;\n";
  print SQLIN "$os_set1\n";
  print SQLIN "$os_set2\n";
  print SQLIN "$sql\n";
  print SQLIN "exit\n";
  close SQLIN;
  
  if ($foreground)
  {
    ##&msg("$os_scmd \@$sqlin");
    system("$os_scmd \@$sqlin");
    #system("$os_scmd <<!
    #  $os_conn;
    #  $os_set1
    #  $os_set2
    #  $sql
    #  exit
    #!");
  }
  else
  {
    @oraSQLout = system("$os_scmd \@$sqlin");
    #@oraSQLout = `$os_scmd <<!
    #  $os_conn;
    #  $os_set1
    #  $os_set2
    #  $sql
    #  ;
    #!`;
  }
}


# --------------------------------------------------------------------
# -shutdown
# --------------------------------------------------------------------
if ($arg eq "-shutdown" || $arg eq "-stop")
{
   $oratab_file = "/etc/oratab";
  if (-f "$oratab_file")
  {
    open (data_in,"$oratab_file");
    @oratab_data=<data_in>;
    close(data_in);
  }
 
  if ($arg3 eq "")
  {
    $shutdown_mode = "immediate";
  }
  elsif ($arg3 eq "normal")
  {
    $shutdown_mode = "normal";
  }
  elsif ($arg3 eq "immediate")
  {
    $shutdown_mode = "immediate";
  }
  elsif ($arg3 eq "abort")
  {
    $shutdown_mode = "abort";
  }

  if ($arg2 eq "-override")
  {
    print "\n-override must be preceeded by \"ALL_INSTANCES\" or \"abort\"\n";
    print "ex: $P -shutdown ALL_INSTANCES -override\n";
    exit 1;
  }
  elsif ($arg2 eq "")
  {
    $shutdown_mode = "immediate";
  }
  elsif ($arg2 eq "ALL_INSTANCES")
  {
    print "Shutting down ALL databases.\n";
  }
  else
  {
      $orig_os = $os;
      $db = "false";
      foreach $line (@oratab_data)
       {
          $_=$line;
          s/^\s//g;
          s/\s+//g;
          $line=$_;
          @words = split(":",$line);
          if (${words[0]} =~ "$arg2")
           { 
             $ENV{"ORACLE_HOME"} = ${words[1]};
             $ENV{"ORACLE_SID"} = $arg2;
             $os = $ENV{"ORACLE_SID"};
             $oh = $ENV{"ORACLE_HOME"};
             $db = "true";
           }
       }

      
      if ($orig_os ne $os)
       {
         print "\nNEW ORACLE_SID: $os\n";
       }

      if ($db eq "false" && $arg2 eq "normal")
       {
          $shutdown_mode = "normal";
       }
      elsif ($db eq "false" && $arg2 eq "immediate")
       {
          $shutdown_mode = "immediate";
       }
      elsif ($db eq "false" && $arg2 eq "abort")
       {
          $shutdown_mode = "abort";
       }

      if ($oh eq "")
       {
          print "oraadmin | ORACLE_HOME could not be determined. Exiting...\n";
          exit 1; 
       }
  }

  if ($arg2 eq "ALL_INSTANCES")
  {
      if ($arg3 eq "-override" || $arg4 eq "-override")
      {
         null;
      } 
      else
      {
         do 
           {
              print "\nAre you sure you want to shutdown ALL Oracle databases on this system?\n";
              print "Enter \"y\" to continue (or \"n\" to cancel shutdown): ";
              $ans = <STDIN>;
              chop($ans);
              if (lc($ans) eq "n" || lc($ans) eq "c")
               {
                  print "User requested cancel.\n";
                  exit;
               } 
           } until (lc($ans) eq "y"); 
      } 

      if ($arg3 eq "abort")
      {
          $shutdown_mode = "immediate";
          print "\nAbort is NOT a valid option for ALL_INSTANCES.\n";
          print "Issuing immediate.\n";
      }
      
      $ENV{"UNIX95"} = 1;
      $cnt=-1;
      print "\nRetrieving a list of databases that are running...\n";
      open(PS, "ps -ef -ocomm |grep ora_pmon|") || die "can't run ps - $!";

      while(<PS>)
       {
          $cnt+=1;
          @words = split;
          $comm = $words[0];
          @comm_words = split ("_",$comm);
          $sid = @comm_words[-1];
          @dbs[$cnt] = $sid; 
        }
      close(PS);

      foreach $sid (@dbs)
      {
          $oh = "";
          $os = $sid;
          $ENV{"ORACLE_SID"} = $sid;
          foreach $line (@oratab_data)
          {
              $_=$line;
              s/^\s//g;
              s/\s+//g;
              $line=$_;
              @words = split(":",$line);
              if (${words[0]} =~ "$sid")
              { 
                  $ENV{"ORACLE_HOME"} = ${words[1]};
                  $oh = $ENV{"ORACLE_HOME"};
              }
          }

          if ($oh eq "")
          {
              print "oraadmin | ORACLE_HOME could not be determined. Skipping...\n";
              next; 
          }

          print "\nNEW ORACLE_SID: $os\n";
          print "-shutdown: Shutdown Oracle - Mode: $shutdown_mode\n";
          system("$oh/bin/$os_scmd <<@ 
          $os_conn
          !echo 'shutdown $shutdown_mode';
          shutdown $shutdown_mode;
          exit;
          @");
      }
  }
  else
  {
      if ($shutdown_mode eq "abort" && $arg3 eq "-override")
      {
         null;
      } 
      elsif ($shutdown_mode eq "abort" && $arg4 eq "-override")
      {
         null;
      } 
      elsif ($shutdown_mode eq "abort")
      {
         do 
           {
              print "\n\"shutdown abort\" should only be issued in extreme cases.\n";
              print "Are you sure you want to issue \"shutdown abort\"?\n";
              print "Enter \"y\" to continue (or \"n\" to cancel shutdown): ";
              $ans = <STDIN>;
              chop($ans);
              if (lc($ans) eq "n" || lc($ans) eq "c")
               {
                  print "User requested cancel.\n";
                  exit;
               } 
           } until (lc($ans) eq "y"); 
      } 
      &msg("-shutdown: Shutdown Oracle -  Mode: $shutdown_mode");
      #system("$oh/bin/$os_scmd <<@ 
      #$os_conn
      #!echo 'shutdown $shutdown_mode';
      #shutdown $shutdown_mode;
      #exit;
      #@");
 
      $sqlstmt = "
      shutdown $shutdown_mode; ";
      oraSQL($sqlstmt,1);
      &msg("running orantstat -m");
      system("perl \\temp\\orantstat.pl -m");
  }
  exit;
}

# --------------------------------------------------------------------
# -listbounce
# --------------------------------------------------------------------
if ($arg eq "-listbounce")
{
  &msg("-listbounce: Bound the listener");
  system("lsnrctl <<@ 
status
stop
start
status
@");
  exit;
}

# --------------------------------------------------------------------
# -killsess
# --------------------------------------------------------------------
if ($arg eq "-killsess")
{
  if ($arg2 eq "" )
  {
    print "$P | killsess Usage: $P -killsess  SESSIONNUMBER,SESSIONSERIAL\n";
    exit 1;
  }
  &msg("Killing session $arg2");

  system("$os_scmd <<@ 2>&1
  $os_conn
  alter system kill session '$arg2';
@");
  exit;
}

# --------------------------------------------------------------------
# -killsessall
# --------------------------------------------------------------------
if ($arg eq "-killsessall")
{
  if ($arg2 ne "!YES!" )
  {
    print "$P | killsessall Usage: $P -killsessall !YES!\n";
    exit 1;
  }
  print "$P | Killing all USER sessions \n";
  open(SE,"orastat -se | grep 'USER ' |") || die 'Cannot run orastat -se';
  $counter = 0;
  while(<SE>)
  {
    ##print; 
    print if /^ORA/;
    @words   = split();
    if ($words[1] eq "USER")
    {
      $string = $words[0];
      print "$P | -killsessall: Killing Session,Serial: $string\n";
      system("$os_scmd <<@ 2>&1
    $os_conn
    alter system kill session '$string';
@");
      $counter++;
    }
  }
  if ($counter == 0) { print "$P | No USER sessions to kill \n"; }
  print "$P | Killed $counter USER sessions \n";
  exit;
}

# --------------------------------------------------------------------
# -killbackup
# --------------------------------------------------------------------
if ($arg eq "-killbackup")
{
  $bkup_count=0;
  $_="\n";
  chomp($arg2);

  open(RO,'$os_scmd <<!
$os_conn
select \'X\',
to_char(logon_time, \'DD-MON-YY\'),
to_char(logon_time, \'HH24:MM:SS\'),
sid,serial#,process,status,module
from v\$session
where module like \'%backup%\';
!|') || die "Error running $os_scmd";

  while (<RO>)
  {
    print if /^ORA/;
    @words   = split();
    $verb    = @words[0];
    $date    = @words[1];
    $time    = @words[2];
    $sid     = @words[3];
    $serial  = @words[4];
    $process = @words[5];

    if ($process eq "ACTIVE" | $process eq "INACTIVE")
    {
      $process = ".";
      $status = @words[5];
    }
    else {$status  = @words[6];}
    $module  = @words[7] . " " . @words[8] . " " . @words[9] . " " . @words[10];
    if ($verb eq "X")
    {

      if ($arg2 ne "all")

       {
       
         do 
           {
            if ($status =~ "KILLED")
              {
                 $answer="n";
              }
            else
              {
                 $bkup_count+=1;
                 print "\n";
                 printf "%9s %9s %8s %9s %8s %10s %s\n", $date, $time, $sid, $serial, $process, $status, $module;

                 print "Do you want to kill this backup: ";
                 $answer=<STDIN>;
                 $_="\n";
                 chomp($answer); 
                 $answer = lc($answer);
               }
           } until  (($answer =~ 'y') || ($answer =~ 'n'));

         if ($answer =~ 'y')
           {
             system("$os_scmd <<@
$os_conn
set serveroutput off;
set echo off;
alter system kill session '$sid,$serial';
@");
 # exit;

           } 
        }
       else
        {
             if (!($status =~ "KILLED"))
               {
                 $bkup_count+=1;
                 printf "%9s %9s %8s %9s %8s %10s %s\n", $date, $time, $sid, $serial, $process, $status, $module;
                 print "Running: alter system kill session \'$sid\,$serial\'\n";
             system("$os_scmd <<@
$os_conn
set serveroutput on;
set echo off;
alter system kill session '$sid,$serial';
@");
                }
        } 
    }
  }

  close(RO);
  
  if ($bkup_count == 0)
    {
       print "\n***No ACTIVE or INACTIVE backup sessions found.***\n\n";
    }
  exit;
}



# --------------------------------------------------------------------
# -checkraw
# --------------------------------------------------------------------
if ($arg eq "-checkraw")
{
  $dir = "/var/opt/oracle/rdisk";
  $blocks = 100;
  if ($arg2 ne "")
  {
    $blocks = $arg2;
  }
  if (chdir("$dir") != 1)
  {
    print "$P | Cannot cd to $dir\n";
    exit 1;
  }
  opendir(RDIR,"$dir");
  @filenames = readdir(RDIR);
  closedir(RDIR);
  foreach (@filenames)
  {
    if (/.dbf$/)
    {
      $file = $_;
      print "$P | dd'ing the first $blocks 2k blocks of raw link $file\n";
      $rc = system("dd if=$file of=/dev/null bs=2k count=$blocks");
      if ($rc != 0)
      {
	print "$P | Error dd'ing $file\n";
	exit 1;
      }
    }

  }
  exit;
}

# --------------------------------------------------------------------
# -analyze
# --------------------------------------------------------------------
if ($arg eq "-analyze")
{
  $mode = "ALL";
  if ($arg2 ne "")
  {
    $mode = $arg2;
  }
  print "-analyze: Mode: $mode arg2=$arg2\n";
  if ($mode ne "SYSTEM" && $mode ne "ALL")
  {
    print "$P | analyze Usage: $P -analyze <SYSTEM | ALL>\n";
    exit 1;
  }

  if ($mode eq "SYSTEM")
  {
    $sql = "
    select 'ANALYZE TABLE \"'||owner||'\".\"'||table_name||
           '\" VALIDATE STRUCTURE CASCADE;'      from dba_tables
      where tablespace_name='SYSTEM';
    select 'ANALYZE CLUSTER \"'||owner||'\".\"'||cluster_name||
           '\" VALIDATE STRUCTURE CASCADE;'      from dba_clusters
      where tablespace_name='SYSTEM';
    ";
  }
  else
  {
    $sql = "
    select 'ANALYZE TABLE \"'||owner||'\".\"'||table_name||
           '\" VALIDATE STRUCTURE CASCADE;'      from dba_tables;
    select 'ANALYZE CLUSTER \"'||owner||'\".\"'||cluster_name||
           '\" VALIDATE STRUCTURE CASCADE;'      from dba_clusters;
    ";
  }

  print "\n\n$P | Building list of tables/clusters\n";
  system("$os_scmd <<@ 
$os_conn
set serveroutput off;
set termout off;
set charwidth 999;
show all;
spool $tmpfile;
$sql
exit;
@");

  # Run statements
  system("grep ^ANALYZE $tmpfile > $tmpfile2");
  print "\n\n$P | Executing ANALYZE statements\n";
  system("$os_scmd <<@ 
$os_conn
set stoponerror on;
set serveroutput on;
@ ${tmpfile2};
exit;
@");

  print "\n\n$P | Done ANALYZE'ing\n";
  exit;
}

# --------------------------------------------------------------------
# -start
# --------------------------------------------------------------------
if ($arg eq "-startup" || $arg eq "-start")
{
   $oratab_file = "/etc/oratab";
  if (-f "$oratab_file")
  {
    open (data_in,"$oratab_file");
    @oratab_data=<data_in>;
    close(data_in);
  }

  if ($arg3 eq "")
  {
    $startup_mode = "open";
  }
  elsif ($arg3 eq "nomount")
  {
    $startup_mode = "nomount";
  }
  elsif ($arg3 eq "mount")
  {
    $startup_mode = "mount";
  }
  elsif ($arg3 eq "open")
  {
    $startup_mode = "open";
  }
  elsif ($arg3 eq "restrict")
  {
    $startup_mode = "restrict";
  }

  if ($arg2 eq "")
  {
    $startup_mode = "open";
  }
  elsif ($arg2 eq "ALL_INSTANCES")
  {
    print "Starting ALL databases.\n";
  }
  else
  {
      $orig_os = $os;
      $db = "false";
      foreach $line (@oratab_data)
       {
          $_=$line;
          s/^\s//g;
          s/\s+//g;
          s/\n//g;
          $line=$_;
          @words = split(":",$line);
          if (${words[0]} =~ "$arg2")
           { 
             $ENV{"ORACLE_HOME"} = ${words[1]};
             $ENV{"ORACLE_SID"} = $arg2;
             $os = $ENV{"ORACLE_SID"};
             $oh = $ENV{"ORACLE_HOME"};
             $db = "true";
           }
       }

      
      if ($orig_os ne $os)
       {
         print "\nNEW ORACLE_SID: $os\n";
       }

      if ($db eq "false" && $arg2 eq "nomount")
       {
          $startup_mode = "nomount";
       }
      elsif ($db eq "false" && $arg2 eq "mount")
       {
          $startup_mode = "mount";
       }
      elsif ($db eq "false" && $arg2 eq "open")
       {
          $startup_mode = "open";
       }
      elsif ($db eq "false" && $arg2 eq "restrict")
       {
          $startup_mode = "restrict";
       }

      if ($oh eq "")
       {
          print "oraadmin | ORACLE_HOME could not be determined. Exiting...\n";
          exit 1; 
       }
  }

  if ($arg2 eq "ALL_INSTANCES")
  {
      print "\n";
      $cnt=-1;
      foreach $line (@oratab_data)
       {
          $_=$line;
          s/^\s//g;
          s/\s+//g;
          $line=$_;
          @words = split(":",$line);
          if (!(${words[0]} =~ "#") && ${words[2]} eq "Y")
           { 
             $cnt+=1;
             @dbs[$cnt] = @words[0];
           }
          elsif (!(${words[0]} =~ "#") && 
                   ${words[2]} ne "Y" &&
                   ${words[0]} ne "")
           { 
             print "WARNING: Will not start ${words[0]} because "; 
             print "$oratab_file indicates \"${words[2]}\"\n"; 
           }
       }

      $ENV{"UNIX95"} = 1;
      $cnt=-1;
      print "\nRetrieving a list of databases that are running...\n";
      open(PS, "ps -ef -ocomm |grep ora_pmon|") || die "can't run ps - $!";

      while(<PS>)
       {
          $cnt+=1;
          @words = split;
          $comm = $words[0];
          @comm_words = split ("_",$comm);
          $sid = @comm_words[-1];
          @running_dbs[$cnt] = $sid;
        }
      close(PS);
      
      foreach $sid (@dbs)
      {
          $db_running = "false";
          foreach $word (@running_dbs)
          {
             if ($word eq $sid)
             {
                $db_running = "true";
             }
          }

          if ($db_running eq "true")
          {
             print "\n\"$sid\" is already running.\n";
             next;
          }
         
          $oh = "";
          $os = $sid;
          $ENV{"ORACLE_SID"} = $sid;
          foreach $line (@oratab_data)
          {
              $_=$line;
              s/^\s//g;
              s/\s+//g;
              $line=$_;
              @words = split(":",$line);
              if (${words[0]} =~ "$sid")
              { 
                  $ENV{"ORACLE_HOME"} = ${words[1]};
                  $oh = $ENV{"ORACLE_HOME"};
              }
          }

          if ($oh eq "")
          {
              print "oraadmin | ORACLE_HOME could not be determined. Skipping...\n";
              next; 
          }

          print "\nNEW ORACLE_SID: $os\n";
          print "-startup: Start Oracle - Mode: $startup_mode\n";
          system("$oh/bin/$os_scmd <<@ 
          $os_conn
          !echo 'startup $startup_mode';
          startup $startup_mode;
          exit;
          @");
      }
  }
  else
  {
      &msg("-startup: Start Oracle -  Mode: $startup_mode");
      $sqlstmt = "startup $startup_mode;";
      oraSQL($sqlstmt,1);
  }
  &msg("running orantstat -m");
  system("perl \\temp\\orantstat.pl -m");
  exit;
}


# --------------------------------------------------------------------
# -startstandby
# --------------------------------------------------------------------
if ($arg eq "-startstandby" || $arg eq "-startupstandby")
{
  if ($arg2 eq "managedrecovery")
  {
    print "-start: StartupStandby Oracle - managedrecovery\n";
    system("$os_scmd <<@ 
    $os_conn
    startup nomount;
    alter database mount standby database;
    !echo \"About to issue 'recover managed standby database;'\"
    recover managed standby database;
    @");
    exit;
  }
  elsif ($arg2 eq "readonly")
  {
    print "-start: StartupStandby Oracle - readonly\n";
    system("$os_scmd <<@ 
    $os_conn
    startup nomount;
    alter database mount standby database;
    !echo \"About to issue 'alter database open read only;'\"
    alter database open read only;
@");
    exit;
  }
  else
  {
    print "-start: StartupStandby Oracle - $arg2\n";
    print "Error: Valid arguments are managedrecovery or readonly \n";
    exit 1;
  }
}

# --------------------------------------------------------------------
# -bounce
# --------------------------------------------------------------------
if ($arg eq "-bounce")
{
  &msg("-bounce: Restart Oracle");
  $sqlstmt = "
shutdown immediate;
startup;";
  oraSQL($sqlstmt,1);
  system("perl \\temp\\orantstat.pl -m");
  exit;
}

# --------------------------------------------------------------------
# -arclog_on
# --------------------------------------------------------------------
if ($arg eq "-arclog_on")
{
  &msg("-arclog_on: Enable Archivelog Mode");
  $sqlstmt = "
shutdown immediate;
startup mount;
alter database archivelog;
alter database open;
  ";
  oraSQL($sqlstmt,1);
  system("perl \\temp\\orantstat.pl -");
  system("perl \\temp\\orantstat.pl -l");
  system("perl \\temp\\orantstat.pl -m");
  exit;
}

# --------------------------------------------------------------------
# -arclog_off
# --------------------------------------------------------------------
if ($arg eq "-arclog_off")
{
  &msg("-arclog_off: Disable Archivelog Mode");
  $sqlstmt = "
shutdown immediate;
startup mount;
alter database noarchivelog;
alter database open;
  ";
  oraSQL($sqlstmt,1);
  system("perl \\temp\\orantstat.pl -");
  system("perl \\temp\\orantstat.pl -l");
  system("perl \\temp\\orantstat.pl -m");
  exit;
}

# --------------------------------------------------------------------
# -switch
# --------------------------------------------------------------------
if ($arg eq "-switch")
{
  print "-switch: Switching logs\n";
  $sqlstmt = "alter system archive log current;";
  oraSQL($sqlstmt,1);
  system("perl \\temp\\orantstat.pl -m");
  exit;
}

# --------------------------------------------------------------------
# -restrict
# --------------------------------------------------------------------
if ($arg eq "-restrictenable")
{
  $arg  = '-restrict';
  $arg2 = 'enable';
}
if ($arg eq "-restrictdisable")
{
  $arg  = '-restrict';
  $arg2 = 'disable';
}
if ($arg eq "-restrict")
{
  print "-restrict: Startup Oracle - Mode: $arg2\n";
  if (uc $arg2 ne "ENABLE" && uc $arg2 ne "DISABLE")
  {
    print "$P | Error: 2nd argument must be enable or disable\n";
    exit 1;
  }
  oraSQL("alter system $arg2 restricted session;",1);
  system("perl \\temp\\orantstat.pl -");
  system("perl \\temp\\orantstat.pl -m");
  exit;
}

# --------------------------------------------------------------------
# -tsreadonly
# --------------------------------------------------------------------
if ($arg eq "-tsreadonly")
{
  open(TS,"orastat -ts | egrep -v '^RBS|^SYSTEM|^TEMP|^USERS|^TOOLS' | grep PERM |") || die "Cannot run orastat -ts";
  while (<TS>)
  {
    @words  = split();
    $ts     = @words[0];
    print "$P | Altering tablespace $ts to READ ONLY\n";
    system("$os_scmd <<@ 
$os_conn
alter tablespace $ts read only;
@");
    $cnt++;
  }
  close(TS);

  print "$P | orastat -ts after altering $cnt tablespaces to READ ONLY\n";
  system("orastat -ts");

  exit;
}


# --------------------------------------------------------------------
# -resize_redo
# --------------------------------------------------------------------
if ($arg eq "-resize_redo")
{
  ### get current sizes

  open(RO,'$os_scmd <<!
  $os_conn
  select \'X\',
  group#, bytes, status from v\$log;
  !|') || die "Cannot OPEN vlog";

  $heading = false;
  $grp_cnt = -1;
  while (<RO>)
  {
    $loop_cnt +=1;
    ##print;
    @words      = split();
    $verb       = @words[0];
    $group      = @words[1];
    $bytes      = @words[2];
    $status     = @words[3];
    if ($verb eq "X")
    {
      if ($bytes >= (1024 * 1024 * 1024))  
        {
           $log_size = $bytes / (1024 * 1024 * 1024);
           $size_label = "GB";
        }
      elsif ($bytes >= (1024 * 1024))  
        {
           $log_size = $bytes / (1024 * 1024);
           $size_label = "MB";
        }
      elsif ($bytes >= 1024)  
        {
           $log_size = $bytes / 1024;
           $size_label = "KB";
        }
      else   
        {
           $log_size = $bytes;
           $size_label = "Bytes";
        }

      $grp_cnt+=1;
      @log_group_no[$grp_cnt] = $group; 
      $log_group{$group}{"size"} = $bytes;
      $log_group{$group}{"status"} = "";
      $log_group{$group}{"member_1"} = "";
      $log_group{$group}{"member_2"} = "";
      $log_group{$group}{"member_3"} = "";
      $log_group{$group}{"member_4"} = "";
      $log_group{$group}{"member_5"} = "";

      if ($heading eq "false")
       {
          print "$P | REDO Log -- Size \n\n";
          print "Group    Status          Size \n";
          print "======= ==========  ==============\n";
          $heading = "true";
       }

      printf ("   %-5d %-10s %12d %-5s\n",$group,$status,$log_size, $size_label);
    }
  }
  close(RO);


  ### get member file names 

  open(RO,'$os_scmd <<!
  $os_conn
  select \'X\',
  group#, member from v\$logfile;
  !|') || die "Cannot OPEN vlogfile";

  $member_cnt = 1;
  $last_group = "";
  while (<RO>)
  {
    ##print;
    @words      = split();
    $verb       = @words[0];
    $group      = @words[1];
    $member      = @words[2];

    if ($verb eq "X")
    {
      if ($group eq $last_group)
        {
          $member_cnt+=1;
        }
      else 
        {
          $member_cnt = 1;
        }
      $log_group{$group}{"member_$member_cnt"} = $member;
      $last_group = $group;
     }
   }
   close(RO);

  ## get block size to determine minimum log size
  open(RO,'$os_scmd <<!
  $os_conn
  select \'X\',
  name, value from v\$parameter;
  !|') || die "Cannot OPEN vparameter";

  while (<RO>)
  {
    ##print;
    @words      = split();
    $verb       = @words[0];
    $name       = @words[1];
    $value      = @words[2];

    if ($verb eq "X")
    {
        if (lc($name) eq "db_block_size")
         {
            $bs = $value;
         }
     }
   }
   close(RO);



   ### allow time for database recovery
   $wait_sec = 30;
   print "Please wait";
   for ($i=1; $i<$wait_sec; $i++)
     {
       print ".";
       sleep (1);
     }
   print "OK";
   print "\n\n";

   ### if only 2 redo log groups exist, create an additional
   ### temporary group

   $temp_log_created = "false";
   $num_log_groups = @log_group_no;
   if ($num_log_groups < 3)
     {

        print "Dropping a redo log group would leave less than 2 logs. \n";
        $last_group_no = @log_group_no[-1];
        $temp_group_no = $last_group_no + 5;
        $last_log_filename = $log_group{$last_group_no}{"member_1"};
        @temp_split_filename = split (/\//,$last_log_filename);
        $temp_short_filename = @temp_split_filename[-1];
        $_=$last_log_filename;
        s/$temp_short_filename//;
        $temp_fs_dir=$_;
        chop($temp_fs_dir);
        $temp_redo_file = "$temp_fs_dir/redo1$temp_group_no$os.log";
        print "Creating temp Redo Log group $temp_group_no...\n";
        print "File name: $temp_redo_file...\n";
        system("$os_scmd <<!
        $os_conn
        !echo 'alter database add logfile group $temp_group_no ('$temp_redo_file') size 128K;';
        alter database add logfile group $temp_group_no ('$temp_redo_file') size 128\K;
        exit;
        !");
        $temp_log_created = $temp_group_no;
        print "\n\n";
     }

   ### prompt user for new size

   $default_size = "10M";
   $new_size = $default_size;
   foreach $group_no (@log_group_no)
     {
        while (1 == 1)  
          {
              print "\n\n";
              print "Enter new size for GROUP \"$group_no\" redo logs--in K or M \(ex: $new_size\) \n";
              print "Press enter for default of \"$new_size\" \(\"s\" to skip, \"q\" to quit\): ";

              $user_size = <STDIN>;
              chop ($user_size);

              if ($user_size eq "q")
               {
                  print "Quiting...\n";
                  exit;
               }
              elsif ($user_size eq "s")
               {
                  print "Skipping group \"$group_no\"...\n";
                  last;
               }
              else 
               {
                 if ($user_size ne "")
                   {
                       $new_size = $user_size;
                   }
                  $label_offset = length($new_size) - 1; 
                  $sl = substr($new_size, $label_offset,1); 
                  if (($sl eq "M") || ($sl eq "K"))
                    {
                       if ($sl eq "M")
                         {
                            $size_kbytes = substr($new_size,0,$label_offset) * 1024; 
                            $size_bytes = substr($new_size,0,$label_offset) * 1024 * 1024; 
                         }
                       elsif ($sl eq "K")
                         {
                            $size_kbytes = substr($new_size,0,$label_offset); 
                            $size_bytes = substr($new_size,0,$label_offset) * 1024; 
                         }
                       if ($size_bytes < $bs)
                         {
                            print "ERROR: log file size 1 blocks is less than minimum 4 blocks\n";
                            print "Minimum size: $bs bytes\n";
                            $sl = "";
                         }
                    }

                  ### if size format is correct, continue

                  if (($sl eq "M") || ($sl eq "K"))
                    {
                       print "New size for redo log group $group_no: $new_size\n";
                       print "\n";
                       $retry_cnt = 0;
                       do 
                         {
                         
                            ### make sure the redo log to be dropped is not current

                            open(RO,'$os_scmd <<!
                            $os_conn
                            select \'X\',
                            group#, status from v\$log;
                            !|') || die "Cannot OPEN vlog";

                            while (<RO>)
                             {
                                ##print;
                                @words      = split();
                                $verb       = @words[0];
                                $group      = @words[1];
                                $status     = @words[2];

                                if (($verb eq "X") && ($group eq $group_no))
                                  {
                                     $log_group{$group_no}{"status"} = $status;
                                     print "status: $status\n";
                                  }
                              }
                            close (RO);

                            ### if log to be dropped is current, switch

                            if ($log_group{$group_no}{"status"} eq "CURRENT")
                              {
                                 print "Switching logfile...\n";
                                 system("$os_scmd <<!
                                 $os_conn
                                 !echo 'alter system switch logfile;';
                                 alter system switch logfile; 
                                 exit;
                                 !");
                                 $retry_cnt+=1;
                                 print "\n\n";
                              }

                            ### if log to be dropped is ACTIVE, switch

                            if (($log_group{$group_no}{"status"} eq "ACTIVE"))
                               {
                                  $sleep_sec = 30;
                                  print "Redo log $group_no is ACTIVE. Sleeping for $sleep_sec sec\(s\)\n";
                                  for ($i=1; $i<$sleep_sec; $i++)
                                    {
                                       print ".";
                                       sleep (1);
                                    }
                                  print "\n\n";
                                  print "Switching logfile...\n";
                                  system("$os_scmd <<!
                                  $os_conn
                                  !echo 'alter system switch logfile;';
                                  alter system switch logfile; 
                                  exit;
                                  !");
                                  print "\n\n";
                                  sleep (5);
                                  $retry_cnt+=1;
                               }

                            ### if log to be dropped is still ACTIVE or CURRENT, skip it

                            if (($log_group{$group_no}{"status"} eq "CURRENT") &&
                                ($retry_cnt == 4))
                               {
                                  print "ERROR: Could not switch logfile. Redo log group $group_no\n";
                                  print "       will NOT be resized. Skipping group $group_no.\n";
                               }

                         } until ((($log_group{$group_no}{"status"} ne "CURRENT") && 
                                  ($log_group{$group_no}{"status"} ne "ACTIVE"))||
                                  ($retry_cnt > 3));

                       $size = $log_group{$group_no}{"size"};
                       $status = $log_group{$group_no}{"status"};
                       $member_1 = $log_group{$group_no}{"member_1"};
                       $member_2 = $log_group{$group_no}{"member_2"};
                       $member_3 = $log_group{$group_no}{"member_3"};
                       $member_4 = $log_group{$group_no}{"member_4"};
                       $member_5 = $log_group{$group_no}{"member_5"};

                       ### drop redo log

                       if (($log_group{$group_no}{"status"} ne "CURRENT") &&
                           ($log_group{$group_no}{"status"} ne "ACTIVE")) 
                         {
                            print "Dropping Redo Log group $group_no...\n";
                            system("$os_scmd <<!
                            $os_conn
                            !echo 'alter database drop logfile group $group_no;';
                            alter database drop logfile group $group_no;
                            exit;
                            !");
                            print "\n\n";
                          }
                            #
                       $log_group{$group_no}{"status"} = "dropped";
                       open(RO,'$os_scmd <<!
                       $os_conn
                       select \'X\',
                       group#, status from v\$log;
                       !|') || die "Cannot OPEN vlog";

                       while (<RO>)
                         {
                            ##print;
                            @words      = split();
                            $verb       = @words[0];
                            $group      = @words[1];
                            $status     = @words[2];

                            if (($verb eq "X") && ($group eq $group_no))
                              {
                                 $log_group{$group_no}{"status"} = $status;
                              }
                         }
                       close(RO);
                       
                       ### if redo log was successfully dropped, continue
 
                       if ($log_group{$group_no}{"status"} eq "dropped")
                         {
                             $group_created = "false";
                             for ($i=1; $i<=5; $i++)
                               { 
                                  $default_filename = $log_group{$group_no}{"member_$i"};
                                  print "\n";
                                  $member_filename = $default_filename;

                                  ### print a warning if only 1 member exists for a group

                                  if (($default_filename eq "") && ($i == 2))
                                    {
                                       print "WARNING: GROUP \"$group_no\" only contains \"1\" member.\n\n";
                                       $member1_filename = $log_group{$group_no}{"member_1"};
                                       print "File name: $member1_filename\n";
                                       $size = $log_group{$group_no}{"size"};
                                       print "Size: $size_kbytes KB\n\n";
                                       print "Press enter to continue...";
                                       $paused=<STDIN>;
                                    }
                                  $fn_retry = 1;
                                  if ($default_filename ne "")
                                    {
                                       ### remove the physical file for the dropped member 

                                       if (-f $default_filename)
                                         { 
                                            print "Removing $default_filename ... ";
                                            system ("rm $default_filename"); 
                                            print "DONE\n";
                                          }
                                  do 
                                    {
                                       ### allows user to change file name and/or location 

                                       print "\n\n";
                                       print "Enter name for GROUP \"$group_no\", MEMBER \"$i\" \(ex: $default_filename\) \n";
                                       print "Press enter for default of \"$default_filename\": ";

                                       $member_filename = <STDIN>;
                                       chop ($member_filename);

                                       if ($member_filename eq "")
                                         {
                                            $member_filename = $default_filename;
                                         }

                                       @split_filename = split (/\//,$member_filename);
                                       $short_filename = @split_filename[-1];
                                       $_=$member_filename;
                                       s/$short_filename//;
                                       $fs_dir=$_;
                                       chop($fs_dir);
                                       chdir($fs_dir); 
                                       ### verify that enough space exists on the fs

                                       $fs_info = `df -kPl . |grep -v Available`;
                                       @split_fs_info = split (' ',$fs_info);
                                       $fs_size = @split_fs_info[3];
                                       print "FS Size: $fs_size KB\n";
                                       if ($size_kbytes >= $fs_size)
                                         {
                                            print "ERROR: $fs_dir isn't large is only $fs_size KB.\n\n";
                                            $fn_retry +=1;
                                         }
                                    } until (($size_kbytes < $fs_size) || ($fn_retry > 2));  

                                  if ($fn_retry > 2)
                                    {
                                       print "ERROR: No supplied files systems had enough space. Skipping...\n\n";
                                       last;
                                    }
                                  else
                                    {
                                       ### create redo log group

                                       if ($group_created ne "true")
                                         {
                                             print "Creating Redo Log GROUP $group_no...\n";
                                             system("$os_scmd <<!
                                             $os_conn
                                             !echo 'alter database add logfile group $group_no ('$member_filename') size $new_size;';
                                             alter database add logfile group $group_no ('$member_filename') size $new_size;
                                             exit;
                                             !");
                                             print "\n\n";
                                             $group_created = "true";
                                         }
                                       else
                                         {
                                             ### add addtl members to redo log group

                                             print "Adding MEMBER $i to GROUP $group_no...\n";
                                             system("$os_scmd <<!
                                             $os_conn
                                             !echo 'alter database add logfile member '$member_filename' to group $group_no;';
                                             alter database add logfile member '$member_filename' to group $group_no;
                                             exit;
                                             !");
                                             print "\n\n";
                                         }
                                    }
                               }
                         } 
                    }

                    last;
                  }
                 else
                    {
                       print "ERROR: Size must end with either \"K\" or \"M\".\n";
                       $new_size = $default_size; 
                    }
               }
          } 
     }

  ### if a temp redo log group was created, remove it

  if ($temp_log_created ne "false")
    {
        do
          {
              open(RO,'$os_scmd <<!
              $os_conn
              select \'X\',
              group#, status from v\$log;
              !|') || die "Cannot OPEN vlog";

              while (<RO>)
                {
                   ##print;
                   @words      = split();
                   $verb       = @words[0];
                   $group      = @words[1];
                   $status     = @words[2];

                   if (($verb eq "X") && ($group eq $temp_log_created))
                     {
                        $log_group{$temp_log_created}{"status"} = $status;
                        print "status: $status\n";
                     }
                }
              close (RO);

              if ($log_group{$temp_log_created}{"status"} eq "CURRENT")
                {
                   print "Switching logfile...\n";
                   system("$os_scmd <<!
                   $os_conn
                   !echo 'alter system switch logfile;';
                   alter system switch logfile; 
                   exit;
                   !");
                   $retry_cnt+=1;
                   print "\n\n";
                }
              if (($log_group{$temp_log_created}{"status"} eq "ACTIVE"))
                {
                   $sleep_sec = 30;
                   print "Redo log $group_no is ACTIVE. Sleeping for $sleep_sec sec\(s\)...\n";
                   sleep($sleep_sec);
                   print "Switching logfile...\n";
                   system("$os_scmd <<!
                   $os_conn
                   !echo 'alter system switch logfile;';
                   alter system switch logfile; 
                   exit;
                   !");
                   print "\n\n";
                   $retry_cnt+=1;
                }
              if (($log_group{$temp_log_created}{"status"} eq "CURRENT") &&
                  ($retry_cnt == 4))
                {
                   print "ERROR: Could not switch logfile. Redo log group $group_no\n";
                   print "       will NOT be resized. Skipping group $group_no.\n";
                }

          } until ((($log_group{$temp_log_created}{"status"} ne "CURRENT") && 
                    ($log_group{$temp_log_created}{"status"} ne "ACTIVE")) ||
                     ($retry_cnt > 3));


        if (($log_group{$temp_log_created}{"status"} ne "CURRENT") &&
            ($log_group{$temp_log_created}{"status"} ne "ACTIVE")) 
          {
              print "Dropping Redo Log group $temp_log_created...\n";
              system("$os_scmd <<!
              $os_conn
              !echo 'alter database drop logfile group $temp_log_created;';
              alter database drop logfile group $temp_log_created;
              exit;
              !");
              print "\n\n";
          }
          
        $log_group{$temp_log_created}{"status"} = "dropped";
        open(RO,'$os_scmd <<!
        $os_conn
        select \'X\',
        group#, status from v\$log;
        !|') || die "Cannot OPEN vlog";

        while (<RO>)
          {
              ##print;
              @words      = split();
              $verb       = @words[0];
              $group      = @words[1];
              $status     = @words[2];

              if (($verb eq "X") && ($group eq $temp_log_created))
                {
                   $log_group{$temp_log_created}{"status"} = $status;
                }
           }
        close(RO);
      
        if ($log_group{$temp_log_created}{"status"} eq "dropped")
           {
              print "Temp redo log group $temp_log_created dropped successfully\n";
              print "Removing $temp_redo_file...";
              system("rm $temp_redo_file"); 
              print "DONE.\n\n";
           } 
        else 
           {
              print "Temp redo log group $temp_log_created could NOT be dropped--drop it manually\n";
              print "alter database drop logfile group $temp_log_created\n\n";
           }
  }

  ### get current sizes

  open(RO,'$os_scmd <<!
  $os_conn
  select \'X\',
  group#, bytes, status from v\$log;
  !|') || die "Cannot OPEN vlog";

  $heading = false;
  $grp_cnt = -1;
  while (<RO>)
  {
    $loop_cnt +=1;
    ##print;
    @words      = split();
    $verb       = @words[0];
    $group      = @words[1];
    $bytes      = @words[2];
    $status     = @words[3];
    if ($verb eq "X")
    {
      if ($bytes >= (1024 * 1024 * 1024))  
        {
           $log_size = $bytes / (1024 * 1024 * 1024);
           $size_label = "GB";
        }
      elsif ($bytes >= (1024 * 1024))  
        {
           $log_size = $bytes / (1024 * 1024);
           $size_label = "MB";
        }
      elsif ($bytes >= 1024)  
        {
           $log_size = $bytes / 1024;
           $size_label = "KB";
        }
      else   
        {
           $log_size = $bytes;
           $size_label = "Bytes";
        }

      if ($heading eq "false")
       {
          print "$P | REDO Log -- Size \n\n";
          print "Group    Status          Size \n";
          print "======= ==========  ==============\n";
          $heading = "true";
       }

      printf ("   %-5d %-10s %12d %-5s\n",$group,$status,$log_size, $size_label);
    }
  }
  close(RO);

  print "\n\n";

  open(RO,'$os_scmd <<!
  $os_conn
  select \'X\',
  group#, member, status from v\$logfile;
  !|') || die "Cannot OPEN vcontrolfile";

  print "$P | REDO Logs - Files\n\n";
  print "Group Name                                               Status\n";
  print "===== ================================================== ====================\n";
  while (<RO>)
  {
    ##print;
    @words = split();
    $verb   = @words[0];
    $group  = @words[1];
    $member = @words[2];
    $status = @words[3];
    if ($verb eq "X")
    {
      printf ("%5d %-50s %-20s \n",$group,$member,$status);
    }
  }
  close(RO);
  print "\n\n";

  ### get member file names 

  print "\n\nDone\n\n";
  exit;
}

# --------------------------------------------------------------------
# resize_df 
# --------------------------------------------------------------------
if ($arg eq "-resize_df")
{
   print "Please wait...\n";
   open (TS,'$os_scmd <<!
   $os_conn
   select \'X\',
         a.tablespace_name as tablespace_name,
          a.sum_bytes as bytes_avail,
          nvl(a.sum_bytes-c.sum_bytes,0) as bytes_used,
          nvl(c.sum_bytes,0) as bytes_free,
          round(nvl((a.sum_bytes-c.sum_bytes),0.00) / a.sum_bytes * 100.0, 2) as pct_used
     from
           (select
              tablespace_name,
              sum(bytes) sum_bytes,
              count(1) max_id
            from
              dba_data_files
            group by
              tablespace_name
          ) a,
          ( select
              tablespace_name,
              sum(bytes) sum_bytes
            from
              dba_free_space
            group by
              tablespace_name
          ) c,
          dba_tablespaces d
    where
          a.tablespace_name = c.tablespace_name (+)
      and a.tablespace_name = d.tablespace_name (+);
     !|') || die "Error running $os_scmd";;
  
   $tscount=0;
   while (<TS>)
   {
     ##print;
     print if /^ORA/;
     @words = split;
     $verb    = @words[0];
     if ($verb eq "X")
     {
       $ts = @words[1];
       @tbs_name[$tscount] = $ts; 
       @tbs_size[$tscount] = @words[2]/1048576;
       @tbs_free[$tscount] = @words[4]/1048576;
       @tbs_used[$tscount] = ${tbs_size[$tscount]} - ${tbs_free[$tscount]};
       @tbs_pct[$tscount] = @words[5];

       $tscount++;
     }
   }
   close(TS);

   do 
   {
      print "\n";
      print ("Please choose a tablespace: \n\n");
      print "    Tablespace         Size(MB)  Free(MB)  Used(MB)    Pct\n";
      print "----------------------------------------------------------------\n";
      $cnt=0;
      foreach $tbs (@tbs_name)
      {
       printf("%2d\) %-20s %-9d %-9d %-9d %-5.1f \n",$cnt,$tbs,${tbs_size[$cnt]},${tbs_free[$cnt]},${tbs_size[$cnt]},${tbs_pct[$cnt]});
         $cnt+=1;
      }
      print "\n";
      print "Choose One: ";
      $ans = <STDIN>;
      chop($ans);
      $ts_name = @tbs_name[$ans];
   } until ($ans >=0 && $ans < $cnt && $ans ne "");
      
   
   print "Please wait...\n";
   open (TS,"$os_scmd <<!
   $os_conn
   select \'X\',
     tablespace_name,
     file_name,
     nvl(bytes,0),
     file_id
     from dba_data_files where tablespace_name = '$ts_name';
     !|") || die "Error running $os_scmd";;

   $dfcount = 0;
   while (<TS>)
   {
     ##print;
     print if /^ORA/;
     @words = split;
     $verb    = @words[0];
     if ($verb eq "X")
     {
       $ts = @words[1];
       $df = @words[2];
       $size = @words[3]/1048576;
       $num = @words[4];

       ##print "num=$num \n";

       if (-c $df)
       {
         $fs = "(Raw)";
       }
       else
       {

         $fs = `df -kPl $df | awk '{ print \$4 }' | tail -1`;
         $fs = sprintf("%9d",$fs / 1024);
       }

       @df_name[$dfcount] = $df; 
       @df_size[$dfcount] = $size; 
       @fs_size[$dfcount] = $fs; 
       $dfcount++;
     }
   }
   close(TS);
   
   do 
   {
      print ("\nPlease choose a datafile to resize: \n");
      print ("    Datafile                                                   Size(MB)  FS Free Space\n");
      print ("--------------------------------------------------------------------------------------\n");
      $cnt=0;
      foreach $df (@df_name)
      {
         $size = @df_size[$cnt];
         $fs = @fs_size[$cnt];
         printf("%2d\) %-55s %9d %9s\n",$cnt,$df,$size,$fs);
         $cnt+=1;
      }
      print "\n";
      print "Choose One: ";
      $ans = <STDIN>;
      chop($ans);
      $df_name = @df_name[$ans];
      
   } until ($ans >=0 && $ans < $cnt && $ans ne "");

   do 
   {
      print ("\nPlease enter a new size (K or M) \n");
      print ("\(ex: 100M\): ");
      $new_size = <STDIN>;
      chop($new_size);
      $new_size = uc($new_size);
      
   } until ($new_size ne "" && (substr($new_size,-1,1) eq "K" || substr($new_size,-1,1) eq "M"));

   $cmd="alter database datafile '$df_name' resize $new_size\;";
   do
   {
      print "\nIs the following correct?\n\n";
      print "\"$cmd\"\n\n";
      print "Answer (\"y\" or \"n\"): ";
      $ans=<STDIN>;
      chop($ans); 
      if (lc($ans) =~ "n")
      {
         print "Exiting...\n";
         exit;
      }
   } until (lc($ans) =~ "y");

   $rc = system("$os_scmd<<@ 
                 $os_conn
                 $cmd
                 exit;
             @");
   if ($rc != 0)
   {
      print "\nERROR: $cmd did NOT complete successfully.\n\n";
   }

   open (TS,'$os_scmd <<!
   $os_conn
   select \'X\',
         a.tablespace_name as tablespace_name,
          a.sum_bytes as bytes_avail,
          nvl(a.sum_bytes-c.sum_bytes,0) as bytes_used,
          nvl(c.sum_bytes,0) as bytes_free,
          round(nvl((a.sum_bytes-c.sum_bytes),0.00) / a.sum_bytes * 100.0, 2) as pct_used
     from
           (select
              tablespace_name,
              sum(bytes) sum_bytes,
              count(1) max_id
            from
              dba_data_files
            group by
              tablespace_name
          ) a,
          ( select
              tablespace_name,
              sum(bytes) sum_bytes
            from
              dba_free_space
            group by
              tablespace_name
          ) c,
          dba_tablespaces d
    where
          a.tablespace_name = c.tablespace_name (+)
      and a.tablespace_name = d.tablespace_name (+);
     !|') || die "Error running $os_scmd";;
  
   print "\nTablespace         Size(MB)  Free(MB)  Used(MB)    Pct\n";
   print "-------------------------------------------------------\n";
   while (<TS>)
   {
     ## print;
     print if /^ORA/;
     @words = split;
     $verb    = @words[0];
     if ($verb eq "X")
     {
       $ts    = @words[1];
       $size  = @words[2]/1048576;
       $free  = @words[4]/1048576;
       $pct   = @words[5];
       $used  = $size - $free;

       if ($ts eq $ts_name)
       {
          printf("%-20s %-9d %-9d %-9d %-5.1f \n\n\n",$ts,$size,$free,$used,$pct);
       }
     }
   }
   close(TS);

   exit;
}

# --------------------------------------------------------------------
# Menu
# --------------------------------------------------------------------

print "oraadmin | Usage:\n";
print "  --            View This Help File\n";
print "  -analyze      Analyze tables/clusters for corruption - arg: [SYSTEM|ALL] - Default ALL\n";
print "  -arclog_on    Enable Archive Log Mode\n";
print "  -arclog_off   Disable Archive Log Mode\n";
print "  -checkraw     dd the first ? 2k blocks from all raw dbf links - args: [Blocks to dd] Default 100\n";
print "  -bounce       shutdown immediate followed by startup\n";
print "  -killbackup   Kill Backup Session(s) - args:  [all] -  Default blank\n";
print "  -killsess     Kill Session - args: [Session#] [Serial#] - No Defaults\n";
print "  -killsessall  Kill All USER Sessions - args: !YES! (mandatory confirmation)\n";
print "  -listbounce   Bounce the listener (stop-start)\n";
print "  -restrict     Restricted session - arg: [enable|disable] - No Default\n";
print "  -resize_df    Resizes a tablespace datafile \n";
print "  -resize_redo  Resizes and/or Relocates Redo Logs \n";
print "  -shutdown     Shutdown instance - arg: [SID|ALL_INSTANCES][normal|immediate|abort][-override] - Default immediate\n";
print "  -start        Synonym for start\n";
print "  -startstandby Startup standby \n";
print "  -startup      Startup instance - arg: [SID|ALL_INSTANCES][nomount|mount|restrict] - Default blank\n";
print "  -stop         Synonym for shutdown\n";
print "  -switch       'alter system archive log current'\n";
print "  -tsreadonly   Alter all non-SYSTEM TS's to READ ONLY\n";
exit 0;
