# -----------------------------------------------------------------------------
sub DownloadSW
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  &debug($thishost, "thishost=$thishost os=$os[$thishost]");

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return; 
  }  

  #---- "Count" this instance
  $iter_instance_count++;

  #---- Do this every iteration !!!
  if ($dbms[$thishost] eq "MSSQL" && $comm_method[$thishost] eq "ssh")
  {
    #---- OLD
    ##---- Get a list of the services running
    #print "DownloadSW - $titleraw[$thishost] | Performing NET START\n";
    #&remsh("net start",$tmpfl2,$thishost);
    #my $services_list = `cat $tmpfl2`;
    #if ($services_list =~ /OpenSSH/i)
    #{
    #  $openssh[$thishost] = 1;
    #  $probe[$thishost] = "dbamon_mssql.pl";
    #  &debug($thishost,"This server runs OpenSSH - probe=$probe[$thishost]");
    #}
    #else
    #{
    #  $openssh[$thishost] = 0;
    #  &debug($thishost,"This server does NOT run OpenSSH");
    #}

    #---- NEW
    #---- Since we always want to run the probe from HOME, we will just hard-code this
    $probe[$thishost] = "dbamon_mssql.pl";
  }
  if ($dbms[$thishost] eq "OracleNT" && $comm_method[$thishost] eq "ssh")
  {
    $probe[$thishost] = "dbamon_orant.pl";
  }

  # Do this only on the 1st iteration
  if ($download_flag[$thishost] == 1 && $download_every[$thishost] ne "Y" && $filecheck eq "")
  {
    &logit("(Already done for this instance)",$thishost);
    return;
  }

  #
  # If we are using ssh, use scp instead of rcp 
  #
  if ($os[$thishost] eq "NT")
  {
    &DownloadSWWin($thishost);
    return;
  }

  #
  # If we are using ssh, use scp instead of rcp 
  #
  if ($comm_method[$thishost] eq "ssh")
  {
    $rcpcmd = "scp";
  }
  else
  {
    $rcpcmd = "rcp";
  }
  #---- Save for later
  $rcpcmd_save[$thishost] = $rcpcmd;

  $hn = "$hostname[$thishost]_$userid[$thishost]";
  &logit("DEBUG download_host{$hn}=$download_host{$hn} orahome[$thishost]=$orahome[$thishost] filecheck=$filecheck",$thishost);

  if ($download_host{$hn} == 1)
  {
    $download_flag[$thishost] = 1;
    $up[$thishost] = "";

    #$hn = $hostname[$thishost];
    #$msg = sprintf("Download already done for host: %s",$hn)
    #&logit($msg,$thishost);

    &logit("Download already done for this host",$thishost);

    &exportVars;

    if ($orahome[$thishost] eq "*" || $filecheck ne "")
    {
      goto PROMOTE_ORAHOME;
    }
    else
    {
      return;
    }
  }

  #---- First connect to server 
  $must_connect = 1;

  #---- 03May05 BB - Create the new /tmp/DBAmon_$userid directory to store the probe
  system("echo ' ' | dbamon_mailer -s 'DBAmon $titleraw[$thishost] probe_dir is NULL' $debug_email") if ! $probe_dir[$thishost];

  &debug($thishost,"mkdir $probe_dir[$thishost] 2>&1;chmod 700 $probe_dir[$thishost] 2>&1;ll $probe_dir[$thishost] 2>&1;uptime");

  &remsh("mkdir $probe_dir[$thishost] 2>&1;chmod 700 $probe_dir[$thishost] 2>&1;ll $probe_dir[$thishost] 2>&1;uptime",$tmpfl2,$thishost);

  ##system("cat $tmpfl2"); 
  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    $up[$thishost] = "D";
    return;
  }

  #
  # Download all uncustomized pgms from /opt/dbamon/bin/download to /tmp
  #
  # added because of EU clusters vd 
  #---- BB 16May50 - Not needed any more
  #system("chmod 777 /opt/dbamon/bin/download/*") ; 

  ##print "DEBUG DownloadSW.pl $titleraw[$thishost] probe_dir=$probe_dir[$thishost] auxcmd=$auxcmd \n";

  &debug($thishost,"$rcpcmd /opt/dbamon/bin/download/* $userid[$thishost]\@$hostname[$thishost]:$probe_dir[$thishost] 2>$tmpfl2");

  if (system("$rcpcmd /opt/dbamon/bin/download/* $userid[$thishost]\@$hostname[$thishost]:$probe_dir[$thishost] 2>$tmpfl2") != 0)
  {
    #
    # Check for pw expired error
    #
    if (system("grep -i 'expired' $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp error - userid=$userid[$thishost] password expired","DnldPswd","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep -i 'disabled' $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp error - userid=$userid[$thishost] account disabled","DnldDisa","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep 'Lost connection' $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp error - userid=$userid[$thishost] lost connection - network problem","DnldNet","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep 'publickey' $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp error - userid=$userid[$thishost] lost connection - ssh auth problem","DnldSSHAuth","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    else
    {
      &event("C",$thishost,"rcp error - userid=$userid[$thishost] Undiagnosable","Dnld","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
  }

  #---- Create and send a require file of parms for this instance - tmpfl6 will contain output
  &exportVars;

  # 
  # Completion Message
  #

  &logit("OK",$thishost);
  $download_flag[$thishost] = 1;
  $up[$thishost] = "";
  $hn = "$hostname[$thishost]_$userid[$thishost]";
  $download_host{$hn} = 1;
  
  &function_cleanup();

  #
  # Ensure that /usr/local/bin/perl on the db server points to perl5
  #

  # Imbed a command to derive the ORACLE_HOME, if * was specified in DBC file
  PROMOTE_ORAHOME: if ($orahome[$thishost] eq "*") 
  {
    $orahomestar[$thishost] = 1;
    $auxcmd = ";grep '^${orasid[$thishost]}:' /etc/oratab";
    $auxflag = 1;
  }
  else
  {
    $orahomestar[$thishost] = 0;
    $auxcmd = "";
    $auxflag = 0;
  }
  ##print "$title[$thishost] auxflag=$auxflag auxcmd=$auxcmd \n";

  if ($filecheck eq "")
  {
    $dummy2 = "";
  }
  else 
  {
    $dummy2 = "ls -l $filecheck 2>/dev/null;";
  } 

  ##print "\n\n dummy2=$dummy2 \n";
  &remsh("${dummy2}/usr/local/bin/perl -v${auxcmd}",$tmpfl2,$thishost);

  ##print "SWEnd title=$title[$thishost]\n";
  ##system("cat $tmpfl2");

  if (system("egrep 'This is perl, version 5|This is perl, v5|perl5' $tmpfl2 > /dev/null") != 0)
  {
    &event("C",$thishost,"/usr/local/bin/perl Does Not Invoke Perl Version 5","Perl","DBA503C",$tmpfl2);
    $up[$thishost] = "D";
    return;
  }
  if (system("grep '$filecheck' $tmpfl2 > /dev/null") != 0 && $id1[$thishost] eq "")
  {
    &event("C",$thishost,"Filecheck: File=$filecheck Not Found","Filecheck","DBA505C",$tmpfl2);
  }
  if ($auxflag)
  {
    $newhome = (split(':',`grep '^${orasid[$thishost]}:' $tmpfl2`)) [1];
    if (substr($newhome,0,1) eq "/") 
    {
      &logit("ORACLE_HOME Promoted from * to $newhome",$thishost);
      $orahome[$thishost] = $newhome; 

      # bb 20sep01 - found a bug where if an instance's entry number changed and the prior
      #  instance in this entry had a value, the new value would not take effect. so, i will
      #  not set save_orahome any more - this will force it to recheck every time
      #$save_orahome[$thishost] = $newhome;

      if ($userid[$thishost] ne "") { $tuserid = " -l $userid[$thishost] "; }
      else                          { $tuserid = " "; }

      if ($comm_method[$thishost] eq "ssh")
      {
        $cmdpfx[$thishost]=
          "ssh $hostname[$thishost] $tuserid '"     .
          "export ORACLE_HOME=$orahome[$thishost];" . 
          "export ORACLE_SID=$orasid[$thishost];"   .
          "export PAGER_EMAIL=$pager_email[$i_hosts];"   .
          "export PATH=\$PATH:$orahome[$thishost]/bin;" ;
      }
      else
      {
	$cmdpfx[$thishost]=
	  "remsh $hostname[$thishost] $tuserid '"    .
	  "export ORACLE_HOME=$orahome[$thishost];"  .
	  "export ORACLE_SID=$orasid[$thishost];"    .
          "export PAGER_EMAIL=$pager_email[$i_hosts];"   .
	  "export PATH=\$PATH:$orahome[$thishost]/bin;";
      }
      &logit("New CMDPFX=$cmdpfx[$thishost]",$thishost);
      
      # Update dbcactive table
      &runSQL("delete from dbamon.dbcactive where dbamonmode = '$modeout' and i_hosts = '$thishost' and text like 'ORACLE_HOME:%'");
      $sqltext = "insert into dbcactive (dbamonmode,i_hosts,text)
        values ('$modeout','$thishost','ORACLE_HOME: $newhome')";
      &runSQL($sqltext);
    }
    else
    {
      &event("C",$thishost,"Unable to find ORACLE_SID=$orasid[$thishost] in /etc/oratab - Unable to convert * to value","OraHm","DBA504C",$tmpfl2);
      $up[$thishost] = "D";
    }
  }
}     

# -----------------------------------------------------------------------------
1;
