# -----------------------------------------------------------------------------
sub infShmem
# Note: this subroutine must follow infLocks
{
  ($thishost) = @_;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (substr($sw_version[$thishost],0,1) lt "7")
  {
    $msg = sprintf("Shared Memory V Seg checking only works on Informix version >= 7");
    &logit($msg,$thishost);
    return 0;
  } 

  ## bb 19May98 - Changed percent increase from 10 to 0 ## recsize = int(shmvsiz[$thishost] * 1.1 / 1000000) * 1000
  $recsize = int($shmvsiz[$thishost] * 1.0 / 1000000) * 1000;

  ##print "vseg=$shmvseg[$thishost] vsiz=$shmvsiz[$thishost] recsize=$recsize \n";

  $shmwarn = 6;
  $shmcrit = 12;

  $z = int($recsize/8);
  open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
  print TMPFL6 "---------------------------------------------------\n";
  print TMPFL6 "Current number of V segments:  $shmvseg[$thishost] \n";
  print TMPFL6 "Current size of V segments:    $shmvsiz[$thishost] \n"; 
  print TMPFL6 "Recommended SHMVIRTSIZE value: $recsize \n";       
  print TMPFL6 "Recommended SHMADD value:      $z \n"; 
  print TMPFL6 "---------------------------------------------------\n";
  close(TMPFL6);

  if ($shmvsiz[$thishost] > 1000000000)
  {
      $msg = sprintf("OK - %s V Segments - SHMVIRTSIZE=%s - V Mem > 1GB - No Action Possible",$shmvseg[$thishost],$shmvirtsize[$thishost]);
      logit($msg,$thishost);
      return;
  }

  if ($shmvirtsize[$thishost] >= $recsize && $shmvseg[$thishost] >= $shmwarn)
  {
      $msg = sprintf("OK - %s V Segments - SHMVIRTSIZE=%s - ONCONFIG already changed",$shmvseg[$thishost],$shmvirtsize[$thishost]);
      &logit($msg,$thishost);
      return;
  }

  if ($shmvseg[$thishost] >= $shmcrit)
  { 
    &event("W",$thishost,"Instance has $shmvseg[$thishost] V shmem segments (critical threshold=$shmcrit)","ShmSeg","DBA310",$tmpfl6);
  }
  else
  {
    if ($shmvseg[$thishost] >= $shmwarn)
    { 
      &event("P",$thishost,"Instance has $shmvseg[$thishost] V shmem segments (warning threshold=$shmwarn)","ShmSeg","DBA311",$tmpfl6);
    }
    else
    {
      $msg = sprintf("OK - %s V Segments",$shmvseg[$thishost]);
      &logit($msg,$thishost);
    }
  } 
}
# -----------------------------------------------------------------------------
1;
